#ifndef SWITCHBUTTON_H
#define SWITCHBUTTON_H

/**
 * 1:ÿذťʽ ԲǾ/Բ/Բ/ͼƬ
 * 2:ѡкδѡʱıɫ
 * 3:ѡкδѡʱĻɫ
 * 4:ʾı
 * 5:û뱳ļ
 * 6:ԲǽǶ
 */

#include <QWidget>

class QTimer;

class SwitchButton: public QWidget
{
    Q_OBJECT
public:
    enum ButtonStyle {
        //ButtonStyle_Rect = 0,     //ԲǾ
        ButtonStyle_CircleIn = 1, //Բ
        //ButtonStyle_CircleOut = 2,//Բ
        ButtonStyle_Image = 3     //ͼƬ
    };

    SwitchButton(QWidget *parent = 0);
    ~SwitchButton();

    void reverseState();

protected:
    void mousePressEvent(QMouseEvent *);
    void resizeEvent(QResizeEvent *);
    void paintEvent(QPaintEvent *);
    void drawBg(QPainter *painter);
    void drawSlider(QPainter *painter);
    void drawText(QPainter *painter);
    void drawImage(QPainter *painter);

private:
    bool checked;               //Ƿѡ
    ButtonStyle buttonStyle;    //ذťʽ

    QColor bgColorOff;          //رʱɫ
    QColor bgColorOn;           //ʱɫ

    QColor sliderColorOff;      //رʱɫ
    QColor sliderColorOn;       //ʱɫ

    QColor textColorOff;        //رʱıɫ
    QColor textColorOn;         //ʱıɫ

    QString textOff;            //رʱʾ
    QString textOn;             //ʱʾ

    QString imageOff;           //رʱʾͼƬ
    QString imageOn;            //ʱʾͼƬ

    int space;                  //뱳
    int rectRadius;             //ԲǽǶ

    int step;                   //ÿƶĲ
    int startX;                 //鿪ʼX
    int endX;                   //X
    QTimer *timer;              //ʱ

private slots:
    void updateValue();

public:
    bool getChecked()const
    {
        return checked;
    }
    ButtonStyle getButtonStyle()const
    {
        return buttonStyle;
    }

    QColor getBgColorOff()const
    {
        return bgColorOff;
    }
    QColor getBgColorOn()const
    {
        return bgColorOn;
    }

    QColor getSliderColorOff()const
    {
        return sliderColorOff;
    }
    QColor getSliderColorOn()const
    {
        return sliderColorOn;
    }

    QColor getTextColorOff()const
    {
        return textColorOff;
    }
    QColor getTextColorOn()const
    {
        return textColorOn;
    }

    QString getTextOff()const
    {
        return textOff;
    }
    QString getTextOn()const
    {
        return textOn;
    }

    QString getImageOff()const
    {
        return imageOff;
    }
    QString getImageOn()const
    {
        return imageOn;
    }

    int getSpace()const
    {
        return space;
    }
    int getRectRadius()const
    {
        return rectRadius;
    }

public slots:
    //Ƿѡ
    void setChecked(bool checked);
    //÷ʽ
    void setButtonStyle(ButtonStyle buttonStyle);

    //ñɫ
    void setBgColor(QColor bgColorOff, QColor bgColorOn);
    //ûɫ
    void setSliderColor(QColor sliderColorOff, QColor sliderColorOn);
    //ıɫ
    void setTextColor(QColor textColorOff, QColor textColorOn);

    //ı
    void setText(QString textOff, QString textOn);

    //ñͼƬ
    void setImage(QString imageOff, QString imageOn);

    //ü
    void setSpace(int space);
    //ԲǽǶ
    void setRectRadius(int rectRadius);


signals:
    void checkedChanged(bool checked);
};

#endif // SWITCHBUTTON_H
